import es,popuplib,gamethread

admins = ["STEAM_0:0:3771609","STEAM_0:0:13654823"]
doorlist = {}
doornames = ["func_door","func_door_rotating","prop_door_rotating"]

def door_entity_list():
    tmplist = {}
    for entity in es.createentitylist():
        tmplist[entity] = {}
        tmplist[entity]["targetname"] = es.entitygetvalue(entity,"targetname")
        tmplist[entity]["classname"] = es.entitygetvalue(entity,"classname")
    return tmplist

def door_get_entity(userid):
    entlist = door_entity_list()
    tn = "door_view_%s"%userid
    es.entsetname(userid,tn)
    for entity in entlist:
        if not es.entitygetvalue(entity,"targetname") == tn: continue
        es.entitysetvalue(entity,"targetname",entlist[entity]["targetname"])
        return [es.entitygetvalue(entity,"classname"),entlist[entity]["targetname"],entity]
    return ["null","null",-1]

def door_fire(entity,func):
    userid = es.getuserid()
    tn = doorlist[int(entity)]["tn"]
    es.entitysetvalue(entity,"targetname","door_menu_tmp_%s"%entity)
    gamethread.delayed(0.1,es.fire,(userid,"door_menu_tmp_%s"%entity,func))
    gamethread.delayed(0.2,es.entitysetvalue,(entity,"targetname",tn))

def door_fire_all(func):
    for entity in doorlist: door_fire(entity,func)

def door_fire_view(userid,func):
    entity = door_get_entity(userid)
    if entity[0] in doornames: door_fire(entity[2],func)
    else: es.tell(userid,"#multi","\x05[Door Menu] You are not looking at a door.")

def door_menu(userid,choice,popupname):
    if choice == 1: door_fire_all("open")
    elif choice == 2: door_fire_all("close")
    elif choice == 3: door_fire_all("lock")
    elif choice == 4: door_fire_all("unlock")
    elif choice == 5:
        door_fire_all("close")
        door_fire_all("lock")
    elif choice == 6:
        door_fire_all("unlock")
        door_fire_all("open")
    elif choice == 7: popuplib.send("door_view",userid)
    elif choice == 8: popuplib.send("door_broswer",userid)
    if choice != 10 and choice not in [7,8]: popuplib.send(popupname,userid)

def door_view(userid,choice,popupname):
    if choice == 1: door_fire_view(userid,"open")
    elif choice == 2: door_fire_view(userid,"close")
    elif choice == 3: door_fire_view(userid,"lock")
    elif choice == 4: door_fire_view(userid,"unlock")
    elif choice == 5:
        door_fire_view(userid,"close")
        door_fire_view(userid,"lock")
    elif choice == 6:
        door_fire_view(userid,"unlock")
        door_fire_view(userid,"open")
    if choice != 10: popuplib.send(popupname,userid)

def door_broswer(userid,choice,popupname):
    popuplib.send("door_broswer_%s"%choice,userid)

def door_broswer_door(userid,choice,popupname):
    entity = popupname.strip("door_broswer_")
    if choice == 1: door_fire(entity,"open")
    elif choice == 2: door_fire(entity,"close")
    elif choice == 3: door_fire(entity,"lock")
    elif choice == 4: door_fire(entity,"unlock")
    elif choice == 5:
        door_fire(entity,"close")
        door_fire(entity,"lock")
    elif choice == 6:
        door_fire(entity,"unlock")
        door_fire(entity,"open")
    if choice != 10: popuplib.send(popupname,userid)
    elif choice == 10: popuplib.send("door_broswer",userid)

def load():
    popup = popuplib.create("doormenu")
    popup.addline("<>Door||Menu<>")
    popup.addline("------------------------")
    popup.addline("->1. <>Open Doors<>")
    popup.addline("->2. <>Close Doors<>")
    popup.addline("->3. <>Lock Doors<>")
    popup.addline("->4. <>Unlock Doors<>")
    popup.addline("->5. <>Close/Lock Doors<>")
    popup.addline("->6. <>Unlock/Open Doors<>")
    popup.addline("->7. <>Door View Menu<>")
    popup.addline("->8. <>Door Broswer<>")
    popup.addline("-------------------------")
    popup.addline("->0. Exit")
    popup.menuselect = door_menu
    popup = popuplib.create("door_view")
    popup.addline("<>Door View||Menu<>")
    popup.addline("------------------------")
    popup.addline("->1. <>Open Door<>")
    popup.addline("->2. <>Close Door<>")
    popup.addline("->3. <>Lock Door<>")
    popup.addline("->4. <>Unlock Door<>")
    popup.addline("->5. <>Close/Lock Door<>")
    popup.addline("->6. <>Unlock/Open Door<>")
    popup.addline("-------------------------")
    popup.addline("->0. Exit")
    popup.submenu(10,"doormenu")
    popup.menuselect = door_view
    door_broswer_create()
    sv = es.ServerVar("mib_door_menu")
    sv.set("1.2")
    sv.makepublic()

def unload():
    popuplib.delete("doormenu")
    popuplib.delete("door_broswer")
    popuplib.delete("door_view")
    for entity in doorlist:
        if popuplib.exists("door_broswer_%s"%entity): popuplib.delete("door_broswer_%s"%entity)

def es_map_start(ev):
    door_broswer_create()

def door_broswer_create():
    popup = popuplib.easymenu("door_broswer",None,door_broswer)
    popup.settitle("<>Door Broswer||Menu<>")
    popup.submenu(10,"doormenu")
    for entity in es.createentitylist():
        cn = es.entitygetvalue(entity,"classname")
        tn = es.entitygetvalue(entity,"targetname")
        if cn in doornames:
            doorlist[entity] = {}
            doorlist[entity]["tn"] = tn
            if tn == "" or tn == " ": tn = "NULL"
            popup.addoption(entity," <>%s - %s<>"%(tn,entity))
            popup2 = popuplib.create("door_broswer_%s"%entity)
            popup2.addline("<>%s - %s||Menu<>"%(tn,entity))
            popup2.addline("------------------------")
            popup2.addline("->1. <>Open Door<>")
            popup2.addline("->2. <>Close Door<>")
            popup2.addline("->3. <>Lock Door<>")
            popup2.addline("->4. <>Unlock Door<>")
            popup2.addline("->5. <>Close/Lock Door<>")
            popup2.addline("->6. <>Unlock/Open Door<>")
            popup2.addline("-------------------------")
            popup2.addline("->0. Exit")
            popup2.menuselect = door_broswer_door

def player_say(ev):
    if ev["text"].lower() == "!doormenu":
        if ev["es_steamid"] in admins: popuplib.send("doormenu",ev["userid"])
        else: es.tell(ev["userid"],"#multi","\x05[Door Menu] You are not a door menu admin.")
